/*
 * 返利明细表
 */

using System;
using System.Web;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Http;
using Microsoft.Extensions.Logging;
using Microsoft.Extensions.Options;
using MySystem.Models;
using Library;
using LitJson;
using MySystemLib;

namespace MySystem.Areas.Admin.Controllers
{
    [Area("Admin")]
    [Route("Admin/[controller]/[action]")]
    public class UserRebateDetailController : BaseController
    {
        public UserRebateDetailController(IHttpContextAccessor accessor, ILogger<BaseController> logger, IOptions<Setting> setting) : base(accessor, logger, setting)
        {
            OtherMySqlConn.connstr = ConfigurationManager.AppSettings["SqlConnStr"].ToString();
        }

        #region 返利明细表列表

        /// <summary>
        /// 根据条件查询返利明细表列表
        /// </summary>
        /// <returns></returns>
        public IActionResult Index(UserRebateDetail data, string right)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;
            

            string Condition = "";
            Condition += "MgrNo:\"" + data.MgrNo + "\",";
Condition += "ProductType:\"" + data.ProductType + "\",";
Condition += "ChannelMerNo:\"" + data.ChannelMerNo + "\",";
Condition += "RebateType:\"" + data.RebateType + "\",";
Condition += "RebateRewardNo:\"" + data.RebateRewardNo + "\",";

            if (!string.IsNullOrEmpty(Condition))
            { 
                Condition = Condition.TrimEnd(',');
                Condition = ", where: {" + Condition + "}";
            }
            ViewBag.Condition = Condition;
            return View();
        }

        #endregion

        #region 根据条件查询返利明细表列表

        /// <summary>
        /// 返利明细表列表
        /// </summary>
        /// <returns></returns>
        public JsonResult IndexData(UserRebateDetail data, int page = 1, int limit = 30)
        {
            
            Dictionary<string, string> Fields = new Dictionary<string, string>();
            
            Fields.Add("CreateDate", "3"); //时间
Fields.Add("MgrNo", "2"); //渠道经理编号
Fields.Add("ProductType", "1"); //产品类型
Fields.Add("ChannelMerNo", "2"); //渠道商户编号
Fields.Add("RebateType", "1"); //返利类型
Fields.Add("RebateRewardNo", "2"); //达标返利单号

            Dictionary<string, object> obj = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).IndexData("UserRebateDetail", Fields, "Id desc", "0", page, limit, " and Status>-1");
            List<Dictionary<string, object>> diclist = obj["data"] as List<Dictionary<string, object>>;
            foreach (Dictionary<string, object> dic in diclist)
            {
                dic["UserId"] = RelationClass.GetUsersInfo(int.Parse(dic["UserId"].ToString()));
dic["MerchantId"] = RelationClass.GetMerchantInfoInfo(int.Parse(dic["MerchantId"].ToString()));

            }
            return Json(obj);
        }

        #endregion

        #region 增加返利明细表

        /// <summary>
        /// 增加或修改返利明细表信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Add(string right)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;
            

            return View();
        }

        #endregion

        #region 增加返利明细表

        /// <summary>
        /// 增加或修改返利明细表信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Add(UserRebateDetail data)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();
            
            Fields.Add("Remark", data.Remark); //备注

            Fields.Add("SeoTitle", data.SeoTitle);
            Fields.Add("SeoKeyword", data.SeoKeyword);
            Fields.Add("SeoDescription", data.SeoDescription);
            int Id = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Add("UserRebateDetail", Fields, 0);
            AddSysLog(data.Id.ToString(), "UserRebateDetail", "add");
            db.SaveChanges();
            
            return "success";
        }

        #endregion

        #region 修改返利明细表

        /// <summary>
        /// 增加或修改返利明细表信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Edit(string right, int Id = 0)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;
            

            UserRebateDetail editData = db.UserRebateDetail.FirstOrDefault(m => m.Id == Id) ?? new UserRebateDetail();
            ViewBag.data = editData;
            return View();
        }

        #endregion

        #region 修改返利明细表

        /// <summary>
        /// 增加或修改返利明细表信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Edit(UserRebateDetail data)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();
            
            Fields.Add("Remark", data.Remark); //备注

            Fields.Add("SeoTitle", data.SeoTitle);
            Fields.Add("SeoKeyword", data.SeoKeyword);
            Fields.Add("SeoDescription", data.SeoDescription);
            new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("UserRebateDetail", Fields, data.Id);
            AddSysLog(data.Id.ToString(),"UserRebateDetail","update");
            db.SaveChanges();
            
            return "success";
        }

        #endregion

        #region 删除返利明细表信息

        /// <summary>
        /// 删除返利明细表信息
        /// </summary>
        /// <returns></returns>
        public string Delete(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id,"UserRebateDetail","del");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", -1);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("UserRebateDetail", Fields, id);
            }
            db.SaveChanges();
            
            return "success";
        }

        #endregion

        #region 开启

        /// <summary>
        /// 开启
        /// </summary>
        /// <returns></returns>
        public string Open(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id,"UserRebateDetail","open");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 1);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("UserRebateDetail", Fields, id);
            }
            db.SaveChanges();
            return "success";
        }

        #endregion

        #region 关闭

        /// <summary>
        /// 关闭
        /// </summary>
        /// <returns></returns>
        public string Close(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id,"UserRebateDetail","close");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 0);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("UserRebateDetail", Fields, id);
            }
            db.SaveChanges();
            return "success";
        }

        #endregion

        #region 排序
        /// <summary>
        /// 排序
        /// </summary>
        /// <param name="Id"></param>
        public string Sort(int Id, int Sort)
        {
            new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Sort("UserRebateDetail", Sort, Id);
            
            AddSysLog(Id.ToString(), "UserRebateDetail", "sort");
            return "success";
        }
        #endregion

        #region 导入数据
        /// <summary>
        /// 导入数据
        /// </summary>
        /// <param name="ExcelData"></param>
        public string Import(string ExcelData)
        {
            ExcelData = HttpUtility.UrlDecode(ExcelData);
            JsonData list = JsonMapper.ToObject(ExcelData);
            for (int i = 1; i < list.Count;i++ )
            {
                JsonData dr = list[i];
                
                db.UserRebateDetail.Add(new UserRebateDetail()
                {
                    CreateDate = DateTime.Now,
                    UpdateDate = DateTime.Now,
                    
                });
                db.SaveChanges();
            }
            AddSysLog("0", "UserRebateDetail", "Import");
            return "success";
        }
        #endregion

        #region 导出Excel

        /// <summary>
        /// 导出Excel
        /// </summary>
        /// <returns></returns>
        public JsonResult ExportExcel(UserRebateDetail data)
        {
            Dictionary<string, string> Fields = new Dictionary<string, string>();
            Fields.Add("CreateDate", "3"); //时间
Fields.Add("MgrNo", "2"); //渠道经理编号
Fields.Add("ProductType", "1"); //产品类型
Fields.Add("ChannelMerNo", "2"); //渠道商户编号
Fields.Add("RebateType", "1"); //返利类型
Fields.Add("RebateRewardNo", "2"); //达标返利单号

            Dictionary<string, object> obj = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).IndexData("UserRebateDetail", Fields, "Id desc", "0", 1, 20000, "", "", false);
            List<Dictionary<string, object>> diclist = obj["data"] as List<Dictionary<string, object>>;
            foreach (Dictionary<string, object> dic in diclist)
            {
                dic["UserId"] = RelationClass.GetUsersInfo(int.Parse(dic["UserId"].ToString()));
dic["MerchantId"] = RelationClass.GetMerchantInfoInfo(int.Parse(dic["MerchantId"].ToString()));

            }

            Dictionary<string, object> result = new Dictionary<string, object>();
            result.Add("Status", "1");
            result.Add("Info", "Excel报表-" + DateTime.Now.ToString("yyyy-MM-ddTHH:mm:ss") + ".xlsx");
            result.Add("Obj", diclist);
            Dictionary<string, object> ReturnFields = new Dictionary<string, object>();
            
            result.Add("Fields", ReturnFields);
            AddSysLog("0", "UserRebateDetail", "ExportExcel");
            return Json(result);
        }

        #endregion

    }
}
